<?php
// *******************************************************************
// Title          udde Instant Messages (uddeIM)
// Description    Instant Messages System for Mambo 4.5.X/Joomla 1.0.0
// Author         Benjamin Zweifel
// Version        0.5 
// as of          2005/12/14
// Contact        uddeim@yahoo.com
// Copyright       by FMQ
// License        This is free software and you may redistribute it under the GPL.
//                uddeIM comes with absolutely no warranty. For details, see the license at
//                http://www.gnu.org/licenses/gpl.txt
//                YOU ARE NOT REQUIRED TO KEEP COPYRIGHT NOTICES IN
//                THE HTML OUTPUT OF THIS SCRIPT. YOU ARE NOT ALLOWED
//                TO REMOVE COPYRIGHT NOTICES FROM THE SOURCE CODE.
// *******************************************************************
// This script contains functions for the archive feature
// *******************************************************************

// Don't allow direct linking

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

function archiveMessage ($myself, $item_id, $messageid) {
	global $config_maxarchive, $config_allowarchive, $config_blocksystem, $config_inboxlimit;
	global $my, $database;

	// if not allowarchive: send back where came from
	if(!$config_allowarchive) {
		$mosmsg=_UDDEIM_ARCHIVENOTENABLED;
		$redirecturl=mosGetParam( $_SERVER, 'HTTP_REFERER', null );
		if (stristr($redirecturl, "archive")) {
			$redirecturl="index.php?option=com_uddeim";
		}

		mosRedirect($redirecturl, $mosmsg);
	}
	
	// code to archive a message
		
	// must only save own messages
	$sql="SELECT count(id) FROM #__uddeim WHERE id=".$messageid." AND toread>0 AND toid=".$myself;
	$database->setQuery($sql);
	$exists=$database->loadResult();
	
	if(!$exists) {
		$mosmsg=_UDDEIM_ARCHIVE_ERROR." (ERR: no message found)"; // debug: softcode
		$redirecturl=mosGetParam( $_SERVER, 'HTTP_REFERER', null );
		mosRedirect($redirecturl, $mosmsg);		
	}
	
	// is the message already saved in archive? 
	$sql="SELECT count(id) FROM #__uddeim WHERE id=".$messageid." AND toread>0 AND toid=".$myself." AND archived>0";
	$database->setQuery($sql);
	$alreadysaved=$database->loadResult();
	
	if($alreadysaved) {
		$mosmsg=_UDDEIM_MESSAGE_ARCHIVED;

	$redirecturl="index.php?option=com_uddeim&task=show&messageid=".$messageid."&Itemid=".$item_id;

		mosRedirect($redirecturl, $mosmsg);			
	}
	
	// count from database all messages I saved
	// if greater than max, don't allow. warning text.
	$arcsql=" AND archived>0";
	if ($config_inboxlimit) {
		$arcsql="";
	}
	
	
	$sql="SELECT count(id) FROM #__uddeim WHERE totrash<1 AND toid=".$myself.$arcsql;
	$database->setQuery($sql);
	$inarchive=$database->loadResult();

	$sql="SELECT gid FROM #__users WHERE id=".$myself;
	$database->setQuery($sql);
	$my_gid=$database->loadResult();	
	
	// if($inarchive >= $config_maxarchive && $my_gid<24) { // JACL support
	if($inarchive >= $config_maxarchive && $my_gid!=24 && $my_gid!=25) {	
		echo "<p>"._UDDEIM_ARC_SAVED_1;
		echo $inarchive;
		echo _UDDEIM_ARC_SAVED_2."</p>\n";
		echo "<p>"._UDDEIM_ARC_SAVED_3."</p>\n";
		$redirecturl=mosGetParam( $_SERVER, 'HTTP_REFERER', null );
		$mosmsg=_UDDEIM_ARCHIVEFULL;
		mosRedirect($redirecturl, $mosmsg);
	}
	
	// update archive flag
	$sql="UPDATE #__uddeim SET archived=1 WHERE id=".$messageid;
	$database->setQuery($sql);
	if (!$database->query()) {
		die("SQL error" . $database->stderr(true));
	}		
	
	// redirect to archived message
	$mosmsg=_UDDEIM_MESSAGE_ARCHIVED;
	$redirecturl="index.php?option=com_uddeim&task=show&messageid=".$messageid."&Itemid=".$item_id;
	mosRedirect($redirecturl, $mosmsg);				
}






function archive($myself, $item_id) {
	global $config_maxarchive;
	global $config_allowarchive;
	global $config_firstwordsinbox;
	global $database, $my, $config_showtitle;
	global $config_showcblink, $config_showcbpic, $config_showonline;
	global $limit, $limitstart, $config_getpiclink, $config_realnames;
	global $uddeicons_onlinepic, $uddeicons_offlinepic, $uddeicons_readpic, $uddeicons_unreadpic, $config_blocksystem, $config_perpage, $config_charset, $config_enabledownload, $config_inboxlimit, $config_allowbb, $config_allowsmile; 

	// if not allowarchive: send back where came from
	if(!$config_allowarchive) {
		$mosmsg=_UDDEIM_ARCHIVENOTENABLED;
		$redirecturl=mosGetParam( $_SERVER, 'HTTP_REFERER', null );
		if (stristr($redirecturl, "archive")) {
			$redirecturl="index.php?option=com_uddeim";
		}

		mosRedirect($redirecturl, $mosmsg);
	}
	
	// count>maxarchive?
	
	// count from archive database all msg where tosave or fromsave is me
	$sql="SELECT count(id) FROM #__uddeim WHERE toid=".$myself." AND totrash<1 AND archived=1";
	$database->setQuery($sql);
	$inarchive=$database->loadResult();

	$totalarchive=$inarchive;
	

	// count inbox against limit?
	
	if($config_inboxlimit) {
		$sql="SELECT count(id) FROM #__uddeim WHERE toid=".$myself." AND totrash<1";
		$database->setQuery($sql);
		$totalarchive=$database->loadResult();
	}
	
	$sql="SELECT gid FROM #__users WHERE id=".$myself;
	$database->setQuery($sql);
	$my_gid=$database->loadResult();	
	
			
	if ($config_inboxlimit) {
		$universeflag=_UDDEIM_ARC_UNIVERSE_BOTH;
	} else {
		$universeflag=_UDDEIM_ARC_UNIVERSE_ARC;
	}
	
	if($totalarchive>0) {	
		$limittext=_UDDEIM_INBOX_LIMIT_1." ".$totalarchive;
		if($totalarchive==1) {
			$limittext.=" "._UDDEIM_INBOX_LIMIT_2_SINGULAR." ";
		} else {
			$limittext.=" "._UDDEIM_INBOX_LIMIT_2." ";
		}
		$limittext.=$universeflag;
		$limittext.=". ";
		// if($totalarchive>=$config_maxarchive && $my_gid<24) { // JACL support
		if($totalarchive>=$config_maxarchive && $my_gid!=24 && $my_gid!=25) {					
			$overlimittext=$limittext;
			$overlimittext.=_UDDEIM_INBOX_LIMIT_3." ".$config_maxarchive.". ";
			$overlimittext.=_UDDEIM_ARC_SAVED_3;
		} else {
			$overlimittext="";
		}
	} else {
		$limittext="";
	}
	
	// now load messages as required
	
	if(!$limitstart) {
		$limitstart=0;
	}
	
	if(!$limit) {
		$limit=$config_perpage;
	}
	
	$total=$inarchive;
	
	// read from archive database all msg where toid is me 
	// this query should return all messages stored by me

	if($config_realnames) {
		$sql="SELECT a.*, b.name AS fromname FROM #__uddeim AS a, #__users AS b WHERE a.toid=".$my->id." AND a.totrash<1 AND a.fromid=b.id AND archived>0 ORDER BY datum DESC LIMIT ".$limitstart.", ".$limit;
	} else {
		$sql="SELECT a.*, b.username AS fromname FROM #__uddeim AS a, #__users AS b WHERE a.toid=".$my->id." AND a.totrash<1 AND a.fromid=b.id AND archived>0 ORDER BY datum DESC LIMIT ".$limitstart.", ".$limit;
	}
	$database->setQuery($sql);
	$allmessages=$database->loadObjectList();

	if($config_getpiclink) {
		$sql="SELECT id, avatar FROM #__comprofiler";
		$database->setQuery($sql);
		$allavatars=$database->loadObjectList();
		foreach($allavatars as $allavatar) {
			$myavatar[$allavatar->id]=$allavatar->avatar;
		}
	}
		
	
	// now do the HTML output, neatly CSSed
	

	if($config_showtitle) {
		echo "<div class='contentheading'>".$config_showtitle."</div>";
	}
	

	
	// write the uddeim menu
	print_uddemenu('archive', $item_id);
	


	echo "<div id='uddeim-overview'>";
	if($inarchive==0) {
		echo "<p>"._UDDEIM_ARC_SAVED_NONE_2."</p>\n</div>\n";
		// and close the HTML output and return
		echo "</div>\n<div id='uddeim-bottomborder'>".contentBottomborder('standard', 'none')."</div>\n</div>\n<!-- uddeIM output above -->\n\n";
		return;
	} 

	
if(!defined('_UDDEIM_UNCHECKALL')) {
	DEFINE('_UDDEIM_UNCHECKALL', 'uncheck all');
	DEFINE('_UDDEIM_CHECKALL', 'check all');
}
	



	?>
	

	<SCRIPT LANGUAGE="JavaScript">

			var marked = "false";
			function check(field) {
				if (marked == "false") {
					for (n = 0; n < arcmes.length; n++) {
						arcmes[n].checked = true;
					}
					marked = "true";
					return <?php _UDDEIM_UNCHECKALL ?>; 
				} else {
					for (n = 0; n < arcmes.length; n++) {
						arcmes[n].checked = false; 
					}
					marked = "false";
					return <?php _UDDEIM_CHECKALL ?>; 
				}
			}
			function wiglwogl(uddeElement) { 
				uddeForm = uddeElement.form; 
				uddeElement = uddeForm.elements[uddeElement.name]; 
				if(uddeElement.length) { 
					bChecked = uddeElement[0].checked; 
					for(i = 1; i < uddeElement.length; i++) 
						uddeElement[i].checked = bChecked; 
				} 
			} 
			function sendDownload() {
				document.messages.action='index.php?option=com_uddeim&task=archivedownload';
				document.messages.submit();
			}
			
			function sendTrash() {
				document.messages.action='index.php?option=com_uddeim&task=archivetrash';			
				document.messages.submit();			
			}
			function checkall(someobject) {
				js_check_all(someobject);
			}
		</script>

<form method="post" name="messages" action='index.php?option=com_uddeim&task=archivefork'>
<?php
	
	// now open the inbox container and table; write table headings
	// echo "<div id='uddeim-overview'>"; 
	echo "<table cellpadding=7 cellspacing=1 width=100%>";
	echo "\n\n\t<tr><th class='sectiontableheader'>";
?>
<input type="checkbox" name="arcmes[]" value="" onclick="wiglwogl(this);" title="<?php echo _UDDEIM_CHECKALL; ?>" />

<?php // debug above (value)
	echo "</th>";
	echo "<th class='sectiontableheader'>"._UDDEIM_FROM."</th><th class='sectiontableheader'>"._UDDEIM_MESSAGE."</th><th class='sectiontableheader'>"._UDDEIM_DATE."</th><th class='sectiontableheader'>&nbsp;</th></tr>";



	$i=1;
	// now write the list
	foreach($allmessages as $themessage) {
		
		// as all messages in archive are READ by design, we will use the readcell
		// for displaying a checkbox (for mass delete, mass download)
		$ischecked="";
		
		$readcell="<input type='checkbox' name='arcmes[]' ".$ischecked." value='".$themessage->id."'>";

		$fromname=$themessage->fromname;

		$personalsys=0;
		if($themessage->systemmessage==$fromname) {
			$personalsys=1;
		}

		if($themessage->systemmessage) {
			$fromname=$themessage->systemmessage;
		}
		

		if(($config_showcblink && !$themessage->systemmessage) || ($config_showcblink && $personalsys)) {
			if($config_getpiclink) {
				$fromcell=getPicLink($themessage->fromid,$fromname, $myavatar[$themessage->fromid]);
			} else {
				$fromcell="<a href=index.php?option=com_comprofiler&task=userProfile&user=".$themessage->fromid.">".$fromname."</a>";
			}
		} else {
			$fromcell=$fromname;
		}
		
		// is this user currently online?

		if (($config_showonline && !$themessage->systemmessage) || ($config_showonline && $personalsys)) {

			$sql="SELECT count(userid) FROM #__session WHERE userid=".$themessage->fromid;
			$database->setQuery($sql);
			$isonline=$database->loadResult();
			if($isonline) {
				$fromcell.=$uddeicons_onlinepic;
			} else {
				$fromcell.=$uddeicons_offlinepic;
			}
		}
		
		$teasermessage=$themessage->message;
		if($themessage->systemmessage || $config_allowbb) {
			// if it is a system message or bb codes allowed, parse BB codes
			$teasermessage=bbcode_strip($teasermessage);
		}
		$teasermessage=teaser(stripslashes($teasermessage), $config_firstwordsinbox);			
		
		$teasermessage=htmlspecialchars($teasermessage, ENT_QUOTES, $config_charset);
		$teasermessage=str_replace("&amp;#", "&#", $teasermessage);
		$safemessage=htmlspecialchars(stripslashes($themessage->message), ENT_QUOTES, $config_charset);
		$messagecell="<a href=index.php?option=com_uddeim&task=show&Itemid=".$item_id."&messageid=".$themessage->id.">".$teasermessage."</a>";
		
		$datumcell=uddeDate($themessage->datum);
		
		$deletecell="<a href=index.php?option=com_uddeim&task=delete&ret=archive&returnlimit=".$limit."&returnlimitstart=".$limitstart."&messageid=".$themessage->id.">"._UDDEIM_DELETELINK."</a>";

		echo "\n\t<tr class='sectiontableentry".$i."'>";
		echo "\n\t\t<td valign='middle'>".$readcell."</td>";
		echo "\n\t\t<td>".$fromcell."</td>";
		echo "\n\t\t<td>".$messagecell."</td>";
		echo "\n\t\t<td>".$datumcell."</td>";
		echo "\n\t\t<td class='pathway'>".$deletecell."</td>";
		echo "</tr>";
		
		$i++;
		if ($i>2) {
			$i=1;
		}
	}

	// now close inbox table and container
	echo "\n</table></div>\n";

	// write the inbox navigation links
	$pageNav = new mosPageNav($total, $limitstart, $limit);
	$referlink="index.php?option=com_uddeim&task=archive&Itemid=".$item_id;
	if($total>$limit) {
		echo "<div id='uddeim-pagenav'>";
		$shownav=$pageNav->writePagesLinks($referlink);
		$shownav=arrowReplace($shownav);
		echo $shownav;		
		echo "<br>";
		echo "[<a href='index.php?option=com_uddeim&task=archive&limitstart=0&limit=".$total."&Itemid=".$item_id."'>"._UDDEIM_SHOWALL."</a>]";
		echo "</div>\n";
	}


echo "</form>";



	echo "<div id='uddeim-bottomlines'><p>";
	if($config_enabledownload) {
		echo '<a href="#" onClick="javascript:sendDownload()">'._UDDEIM_EXPORT_NOW.'</a> | ';
	}
	echo '<a href="#" onClick="javascript:sendTrash()">'._UDDEIM_TRASHCHECKED.'</a>';
	echo "</p>\n</div>\n";

	if($overlimittext) {
		$limittext="";
		echo "\n<div 'uddeim-bottomlines'><p class='uddeim-warning'>";
		echo $overlimittext;
		echo "</span>\n</div>";
	}
	
	if($limittext) {
		echo "</div>\n<div id='uddeim-bottomborder'>".contentBottomborder('standard', $limittext)."</div>\n</div>\n<!-- uddeIM output above -->\n";	
	} else {
		echo "</div>\n<div id='uddeim-bottomborder'>".contentBottomborder('standard', 'none')."</div>\n</div>\n<!-- uddeIM output above -->\n";
	}
}









function archiveTrash($myself, $item_id, $arcmes) {
	global $config_maxarchive;
	global $config_allowarchive;
	global $database, $my;
	global $returnlimit, $returnlimitstart;

	// mass trash

	// if not allowarchive: send back where came from
	if(!$config_allowarchive) {
		$mosmsg=_UDDEIM_ARCHIVENOTENABLED;
		$redirecturl=mosGetParam( $_SERVER, 'HTTP_REFERER', null );
		if (stristr($redirecturl, "archive")) {
			$redirecturl="index.php?option=com_uddeim";
		}
		mosRedirect($redirecturl, $mosmsg);
	}


	
	// process items
	$n = count($arcmes);
	
	for($i = 0; $i <= ($n); $i++) {
		$rightnow=uddetime();
		if($arcmes[$i]>0) {
			$sql="UPDATE #__uddeim SET totrash=1, totrashdate=".$rightnow." WHERE toid=".$myself." AND  id=".$arcmes[$i];
			$database->setQuery($sql);
			if (!$database->query()) {
				die("SQL error" . $database->stderr(true));
			}				
		}
	}
	
	$redirecturl="index.php?option=com_uddeim&task=archive&Itemid=".$item_id."&limit=".$returnlimit."&limitstart=".$returnlimitstart;
	mosRedirect($redirecturl);
	
}







function archiveDownload($myself, $item_id, $arcmes) {
	global $config_maxarchive;
	global $config_allowarchive;
	global $config_maxarchive;
	global $config_allowarchive;
	global $database, $my;
	global $returnlimit, $returnlimitstart;
	global $mosConfig_sitename, $config_charset, $config_mailcharset;
	global $config_emn_sendermail, $config_emn_sendername, $config_enabledownload;
	global $config_emailtrafficenabled;
	
	// if e-mail traffic stopped, don't send.
	if(!$config_emailtrafficenabled>0) {
		$redirecturl="index.php?option=com_uddeim&task=archive";
		mosRedirect($redirecturl, $mosmsg);
	}
	
	// if not allowarchive: send back where came from
	if(!$config_allowarchive || !$config_enabledownload) {
		$mosmsg=_UDDEIM_ARCHIVENOTENABLED;
		$redirecturl=mosGetParam( $_SERVER, 'HTTP_REFERER', null );
		if (stristr($redirecturl, "archive")) {
			$redirecturl="index.php?option=com_uddeim";
		}
		mosRedirect($redirecturl, $mosmsg);
	}

	$clrf=chr(10);
	
	$htmlstring='<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"><html><head>	<title>';
	$htmlstring.=$mosConfig_sitename._UDDEIM_MESSAGEDOWNLOAD;
	$htmlstring.='</title></head><body><h2>';
	
	$exportstring=$my->username." "._UDDEIM_MESSAGEDOWNLOAD;
	$htmlstring.=$my->username." "._UDDEIM_MESSAGEDOWNLOAD;
	
	$htmlstring.='</h2><h4>'.uddeLdate(uddetime()).'</h4><!-- generated by uddeIM messaging component --><table cellspacing=0 cellpadding=4 border=0>';
	
	$exportstring.=" - ";
	$exportstring.=$mosConfig_sitename.$clrf;
	$rightnow=uddetime();
	$exportstring.=uddeLdate($rightnow);
	$exportstring.=$clrf.$clrf.$clrf;
	
	$maindivider="================================================================================".$clrf;
	
	$exportstring.=$maindivider;
	
	$counter=0;
	
	// process items
	$n = count($arcmes);

	for($i = 0; $i <= ($n-1); $i++)
	{
		
		
		$sql="SELECT a.*, b.username AS fromname FROM #__uddeim AS a, #__users AS b WHERE a.id=".$arcmes[$i]." AND a.toid=".$myself." AND a.archived>0 AND a.fromid=b.id";
		$database->setQuery($sql);
		$trashs=$database->loadObjectList();
		$howmany=count($trashs);
		foreach($trashs as $trash) {

		if(!$trash->systemmessage) {
			$headstring=$trash->fromname;
		} else {
			$headstring=$trash->systemmessage;
		}

		// $headstring.=" (".uddeLdate($trash->datum).")";
		// $headdivider=str_repeat("=", strlen($headstring));
		
		// $exportstring.="     ".$headstring.$clrf."     ".$headdivider.$clrf.$clrf;
		
		$dlmsg=stripslashes($trash->message);
		// bbcode strip
		
		$dlmsg=bbcode_strip($dlmsg);
		
		// $exportstring.=stripslashes($dlmsg);
		// $exportstring.=$clrf.$clrf.$clrf.$clrf;
		// $exportstring.=$maindivider;
		
		$exportstring.=_UDDEIM_EXPORT_FORMAT;
		$exportstring=str_replace("%user%", $headstring, $exportstring);
		$exportstring=str_replace("%msgdate%", uddeLdate($trash->datum), $exportstring);
		$exportstring=str_replace("%msgbody%", $dlmsg, $exportstring);				
		
		$htmlstring.='\n\t<tr bgcolor=#cccccc>
		\n\t\t<td><strong>'.$trash->fromname.'</strong></td>
		\n\t\t<td align=right>'.uddeLdate($trash->datum).'</td></tr>\n\n\t<tr>\n\t\t<td>&nbsp;</td>\n\t\t<td>';
		// bbcode strip
		
		$htmlstring.=nl2br(stripslashes($dlmsg));
		$htmlstring.='</td></tr>';

		
		$counter++;
		}
	}
	
	$htmlstring.="\n</table>\n</body>\n</html>\n";
	
	if(!$counter) {
		echo _UDDEIM_NOMSGSELECTED;
		echo "<br />";
		echo "<a href='javascript:history.go(-1)'>"._UDDEIM_BACK."</a>";
		return;
	}
	
	// we now have $exportstring and $htmlstring (text and html respecitvely) as files
	// with all checked messages (in arcmes[])
	
	$sql="SELECT username, email FROM #__users WHERE `id`=".$myself;
	$database->setQuery($sql);
	$results=$database->loadObjectList();
	
	if(!$results) {
	}
	
	foreach($results as $result) {
		$var_toname=$result->username;
		$var_tomail=$result->email;
	}
	
	if(!$var_tomail) {
		$mosmsg=_UDDEIM_EXPORT_COULDNOTSEND;
		$redirecturl="index.php?option=com_uddeim&task=archive";
		mosRedirect($redirecturl, $mosmsg);
	}
	
	$subject=$mosConfig_sitename." "._UDDEIM_MESSAGEDOWNLOAD;
	
	
	

	$header  = "MIME-Version: 1.0\n";
	// $header .= "Content-type: text/plain; charset=iso-8859-1\n";
	$header .= "Content-type: text/plain; charset=".getCharsetname($config_mailcharset)."\n";
	$header .= "Organization: ".$mosConfig_sitename."\n";
	$header .= "Content-Transfer-encoding: 8bit\n";
	$header .= "From: \"".$config_emn_sendername."\" <".$config_emn_sendermail.">\n";
	$header .= "Reply-To: ".$config_emn_sendermail."\n";
	$header .= "Message-ID: <".md5(uniqid(uddetime()))."@{$_SERVER['SERVER_NAME']}>\n";
	$header .= "Return-Path: ".$config_emn_sendermail."\n";            
	$header .= "X-Priority: 3\n"; 
	$header .= "X-MSmail-Priority: Low\n"; 
    // $header .= "X-Mailer: PHP\r\n"; 
	$header .= "X-Mailer: Microsoft Office Outlook, Build 11.0.5510\n";
	$header .= "X-Sender: ".$config_emn_sendermail."\n";
            
	if(mail ($var_tomail,$subject,$exportstring,$header)) {
		$mosmsg=_UDDEIM_EXPORT_MAILED;
	} else {
		$mosmsg=_UDDEIM_EXPORT_COULDNOTSEND;
	}

	
	$redirecturl="index.php?option=com_uddeim&task=archive";
	mosRedirect($redirecturl, $mosmsg);
	
}







?>